### Overview

The addon is split into a few modules:
- flsys.lua: Main addon, core functionality. Always loaded if addon is enabled.
- fldist.lua: Handles loot drops and loot distribution. Only loaded when a raid is started.
- flopt.lua: Options panel for configuring and managing team roster. Only loaded when flml options panel is opened.

`flsys` is split into many files by function - everything in `/components` is part of the `flsys` addon.  The idea is to make the code easier to navigate without creating a lot of additional tables in-game.

Most of the static/base user interface components are defined in `flsysframes.xml` and `distframes.xml`

### TODO/in progress

TODO - WoD update
- Calculate GP for new tier drops
- Update default ilvl
- Update options

TODO - code
- Clearer naming of itable, etc.
- Update testing functions
  - Automated tests?
- Reducing complexity of some of the core flow - updatePR, etc.
- look into a full module that loads only in raids (combine dist with comp/raid)
- More consistent UI definitions
  - Move event handlers out of xml
  - Move static parts into xml
- Style
  - Single quotes

### Data overview - major tables

Roll
- player, string
- rolltype, string, see rollorder table in fldist
- rollstr, string, display/human-friendly roll type (need, disenchant, etc)

loot

### UI overview - major frames

Standings - `FLStandings`
/fss
Main window. Shows players, ep, gp, pr. Buttons for accessing log, starting/ending raids

Log - `FLLog`
Accessible via button on standings frame.
Shows past awards, decays, etc. Button for exporting.

Roll progress - `FLProgressFrame`
Shown once rolling has started, until everyone rolls or the ml ends it manually.
Shows player name and number of rolls received - highlight indicates whether they're done

Awarding - `FLAwardFrame`
Pops up when rolling is done.
Shows each loot item with winner. Hover shows all rollers. Click to award.


### Organizing code - notes

topic - comm, loot item, etc.
in raid/out of raid - lots of overlap
area - ui, system/db, distribution

ways to split
- modules
- files within same module
- organization within file

### Code ideas

Class candidates
- roll on loot
- loot item

