--- Handles loot from the system/data side: mainly calculating GP

-- following tables modified from LibGearPoints-1.2 (EPGP)
local EQUIPSLOT_MULTIPLIER_1 = {
  INVTYPE_HEAD = 1,
  INVTYPE_NECK = 0.5,
  INVTYPE_SHOULDER = 0.75,
  INVTYPE_CHEST = 1,
  INVTYPE_ROBE = 1,
  INVTYPE_WAIST = 0.75,
  INVTYPE_LEGS = 1,
  INVTYPE_FEET = 0.75,
  INVTYPE_WRIST = 0.5,
  INVTYPE_HAND = 0.75,
  INVTYPE_FINGER = 0.5,
  INVTYPE_TRINKET = 1,
  INVTYPE_CLOAK = 0.5,
  INVTYPE_WEAPON = 1.5,
  INVTYPE_SHIELD = 1.5,
  INVTYPE_2HWEAPON = 2,
  INVTYPE_WEAPONMAINHAND = 1,
  INVTYPE_WEAPONOFFHAND = 1,
  INVTYPE_HOLDABLE = 0.5, --off-hand frill
  INVTYPE_RANGED = 2, --bow
  INVTYPE_RANGEDRIGHT = 2, --wand, crossbow or gun
}
local EQUIPSLOT_MULTIPLIER_2 = {
  INVTYPE_WEAPON = 0.5, --tanking = .5, other main hand = 1.5
  INVTYPE_SHIELD = 0.5, --tanking shields = 1.5, shaman = .5
  INVTYPE_RANGEDRIGHT = 1.5, --wands = 1.5, xbow/gun = 2
}

local CUSTOM_ITEM_DATA = {
  --T14 normal
  [89234] = { 496, 'INVTYPE_HEAD' },
  [89235] = { 496, 'INVTYPE_HEAD' },
  [89236] = { 496, 'INVTYPE_HEAD' },
  [89237] = { 496, 'INVTYPE_CHEST' },
  [89238] = { 496, 'INVTYPE_CHEST' },
  [89239] = { 496, 'INVTYPE_CHEST' },
  [89240] = { 496, 'INVTYPE_HAND' },
  [89241] = { 496, 'INVTYPE_HAND' },
  [89242] = { 496, 'INVTYPE_HAND' },
  [89243] = { 496, 'INVTYPE_LEGS' },
  [89244] = { 496, 'INVTYPE_LEGS' },
  [89245] = { 496, 'INVTYPE_LEGS' },
  [89246] = { 496, 'INVTYPE_SHOULDER' },
  [89247] = { 496, 'INVTYPE_SHOULDER' },
  [89248] = { 496, 'INVTYPE_SHOULDER' },
  --T14 heroic
  [89249] = { 509, 'INVTYPE_CHEST' },
  [89250] = { 509, 'INVTYPE_CHEST' },
  [89251] = { 509, 'INVTYPE_CHEST' },
  [89252] = { 509, 'INVTYPE_LEGS' },
  [89253] = { 509, 'INVTYPE_LEGS' },
  [89254] = { 509, 'INVTYPE_LEGS' },
  [89255] = { 509, 'INVTYPE_HAND' },
  [89256] = { 509, 'INVTYPE_HAND' },
  [89257] = { 509, 'INVTYPE_HAND' },
  [89258] = { 509, 'INVTYPE_HEAD' },
  [89259] = { 509, 'INVTYPE_HEAD' },
  [89260] = { 509, 'INVTYPE_HEAD' },
  [89261] = { 509, 'INVTYPE_SHOULDER' },
  [89262] = { 509, 'INVTYPE_SHOULDER' },
  [89263] = { 509, 'INVTYPE_SHOULDER' },
  -- T15 normal
  [95573] = { 522, 'INVTYPE_SHOULDER' },
  [95583] = { 522, 'INVTYPE_SHOULDER' },
  [95578] = { 522, 'INVTYPE_SHOULDER' },
  [95572] = { 522, 'INVTYPE_LEGS' },
  [95581] = { 522, 'INVTYPE_LEGS' },
  [95576] = { 522, 'INVTYPE_LEGS' },
  [95571] = { 522, 'INVTYPE_HEAD' },
  [95582] = { 522, 'INVTYPE_HEAD' },
  [95577] = { 522, 'INVTYPE_HEAD' },
  [95570] = { 522, 'INVTYPE_HAND' },
  [95580] = { 522, 'INVTYPE_HAND' },
  [95575] = { 522, 'INVTYPE_HAND' },
  [95569] = { 522, 'INVTYPE_CHEST' },
  [95579] = { 522, 'INVTYPE_CHEST' },
  [95574] = { 522, 'INVTYPE_CHEST' },
  -- T15 heroic
  [96699] = { 535, 'INVTYPE_SHOULDER' },
  [96700] = { 535, 'INVTYPE_SHOULDER' },
  [96701] = { 535, 'INVTYPE_SHOULDER' },
  [96631] = { 535, 'INVTYPE_LEGS' },
  [96632] = { 535, 'INVTYPE_LEGS' },
  [96633] = { 535, 'INVTYPE_LEGS' },
  [96625] = { 535, 'INVTYPE_HEAD' },
  [96623] = { 535, 'INVTYPE_HEAD' },
  [96624] = { 535, 'INVTYPE_HEAD' },
  [96599] = { 535, 'INVTYPE_HAND' },
  [96600] = { 535, 'INVTYPE_HAND' },
  [96601] = { 535, 'INVTYPE_HAND' },
  [96567] = { 535, 'INVTYPE_CHEST' },
  [96568] = { 535, 'INVTYPE_CHEST' },
  [96566] = { 535, 'INVTYPE_CHEST' },
  -- T16 Normal
  [99685] = { 553, 'INVTYPE_SHOULDER' },
  [99695] = { 553, 'INVTYPE_SHOULDER' },
  [99690] = { 553, 'INVTYPE_SHOULDER' },
  [99684] = { 553, 'INVTYPE_LEGS' },
  [99693] = { 553, 'INVTYPE_LEGS' },
  [99688] = { 553, 'INVTYPE_LEGS' },
  [99683] = { 553, 'INVTYPE_HEAD' },
  [99694] = { 553, 'INVTYPE_HEAD' },
  [99689] = { 553, 'INVTYPE_HEAD' },
  [99682] = { 553, 'INVTYPE_HAND' },
  [99692] = { 553, 'INVTYPE_HAND' },
  [99687] = { 553, 'INVTYPE_HAND' },
  [99696] = { 553, 'INVTYPE_CHEST' },
  [99691] = { 553, 'INVTYPE_CHEST' },
  [99686] = { 553, 'INVTYPE_CHEST' },
  -- T16 Normal Essences
  [105857] = { 553, 'INVTYPE_HEAD' },
  [105859] = { 553, 'INVTYPE_HEAD' },
  [105858] = { 553, 'INVTYPE_HEAD' },
  -- T16 Heroic (Mythic after 6.0)
  [99717] = { 566, 'INVTYPE_SHOULDER' },
  [99719] = { 566, 'INVTYPE_SHOULDER' },
  [99718] = { 566, 'INVTYPE_SHOULDER' },
  [99726] = { 566, 'INVTYPE_LEGS' },
  [99713] = { 566, 'INVTYPE_LEGS' },
  [99712] = { 566, 'INVTYPE_LEGS' },
  [99723] = { 566, 'INVTYPE_HEAD' },
  [99725] = { 566, 'INVTYPE_HEAD' },
  [99724] = { 566, 'INVTYPE_HEAD' },
  [99720] = { 566, 'INVTYPE_HAND' },
  [99722] = { 566, 'INVTYPE_HAND' },
  [99721] = { 566, 'INVTYPE_HAND' },
  [99714] = { 566, 'INVTYPE_CHEST' },
  [99716] = { 566, 'INVTYPE_CHEST' },
  [99715] = { 566, 'INVTYPE_CHEST' },
  -- T17
  [119309] = { 665, "INVTYPE_SHOULDER" },
  [119322] = { 665, "INVTYPE_SHOULDER" },
  [119314] = { 665, "INVTYPE_SHOULDER" },

  [119307] = { 665, "INVTYPE_LEGS" },
  [119320] = { 665, "INVTYPE_LEGS" },
  [119313] = { 665, "INVTYPE_LEGS" },

  [119308] = { 665, "INVTYPE_HEAD" },
  [119321] = { 665, "INVTYPE_HEAD" },
  [119312] = { 665, "INVTYPE_HEAD" },

  [119306] = { 665, "INVTYPE_HAND" },
  [119319] = { 665, "INVTYPE_HAND" },
  [119311] = { 665, "INVTYPE_HAND" },

  [119305] = { 665, "INVTYPE_CHEST" },
  [119318] = { 665, "INVTYPE_CHEST" },
  [119315] = { 665, "INVTYPE_CHEST" },

  -- T17 essenc
  [119310] = { 665, "INVTYPE_HEAD" },
  [120277] = { 665, "INVTYPE_HEAD" },
  [119323] = { 665, "INVTYPE_HEAD" },
  [120279] = { 665, "INVTYPE_HEAD" },
  [119316] = { 665, "INVTYPE_HEAD" },
  [120278] = { 665, "INVTYPE_HEAD" }
}

local function GetBonusItemLevel(link)
  -- example normal & heroic:
  -- item:119320:0:0:0:0:0:0:0:null:0:0:1:0|h[Leggings of the Iron Protector]|h|r
  -- item:119320:0:0:0:0:0:0:0:null:0:0:1:570|h[Leggings of the Iron Protector]|h|r
  local item_string = string.match(link, 'item:[%-?%d:]+')
  local components = { strsplit(':', item_string) }
  if #components >= 14 then
    local bonus = components[14]
    flsys:Debug(1, 'ITEM', 'Found bonus of ' .. bonus .. ' for ' .. link)
    return LEVEL_MODIFIERS[tonumber(bonus)] or 0
  end
  return 0
end


function flsys:GetValue(level, itemid, equipLoc, link)
  -- function adapted from LibGearPoints-1.2 (EPGP)
  if flsys.db.mode ~= 2.2 then
    itemid = tonumber(itemid)
    if CUSTOM_ITEM_DATA[itemid] then
      flsys:Debug(3, 'Looking up custom data')
      level, equipLoc = unpack(CUSTOM_ITEM_DATA[itemid])
      if level >= 665 then
        level = level + GetBonusItemLevel(link)
      end
    end

    local slot_multiplier1 = EQUIPSLOT_MULTIPLIER_1[equipLoc]
    local slot_multiplier2 = EQUIPSLOT_MULTIPLIER_2[equipLoc]
    if not slot_multiplier1 then
      flsys:Debug(3, 'no slot multiplier; returning 0')
      return 0
    end

    local gp_base = 1000 * 2^((level - flsys.db.standard_ilvl)/26)
    local high = math.floor(0.5 + gp_base * slot_multiplier1)
    local low = slot_multiplier2 and math.floor(0.5 + gp_base * slot_multiplier2) or nil
    flsys:Debug(3, 'Returning '..high..' GP value')
    return high, low
  else
    return 1
  end
end

local LEVEL_MODIFIERS = {
  [566] = 15,
  [570] = 15,
  [567] = 30,
  [569] = 30
}

