--- Utility functions

function flsys:Round(num, dp)
  local mult = 10^(dp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function flsys:TextTooltip(owner, text)
  GameTooltip:SetOwner(owner, "ANCHOR_RIGHT")
  GameTooltip:SetText(text)
  GameTooltip:Show()
end

function flsys:Print(text)
  if text then
    DEFAULT_CHAT_FRAME:AddMessage("|cff6600FFflsys:|r "..tostring(text))
  end
end

function flsys:Cap(str)
  local capstr = ""
  for word in string.gmatch (str, "[^%s]+") do
    if word~="of" and word~="the" and word~="and" and word~="a" and word~="or" then
      word = (word:gsub("^%l", string.upper))
    end
    capstr = capstr..word.." "
  end
  return string.sub(capstr, 1, -2)
end

local LOG_LEVELS = { --TODO implement more readable log system (see below)
  ERROR = 0,
  WARNING = 1,
  INFO = 2,
  DEBUG = 3
}

function flsys:Debug(lvl, logtype, ...)
  if lvl <= flsys.db.debuglevel then
    table.insert(flsys.log.profile, date("%m/%d %H:%M:%S").."---"..logtype.."---"..(table.concat({...}, " ")))
  end
end

function flsys:Info(logtype, ...)
  self:Debug(LOG_LEVELS.INFO, logtype, ...)
end

function flsys:TrimDebug()
  for i = 1001, #flsys.log.profile do
    table.remove(flsys.log.profile, 1)
  end
end


